//+------------------------------------------------------------------+
//|                                                      20PRExp.mq4 |
//|                          Copyright  2006, HomeSoft-Tartan Corp. |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, Sergey G. Gulikin"
#property link      ""

extern int zazor = 20;
int j = 0;
bool ft = true;
int blok = 0;
int s = 0;
int b = 0;

int top = 0;
int del = 0;

double MidL = 0,MLP = 0,MLM = 0;

string dw = " ";

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
   j=j+1; 
 
   if((Minute()==0) && (Seconds()<=15))
   {
      j=0;
   }

   if((Hour()==0 && Minute()<5) || (ft==true))
   {
      blok=0; s=0; b=0;
      
      if(ft==true)
      {
         top = MathRound((Hour()*60+Minute())/Period())+1;
      } else {
         top=1;
      }
      
      MidL=Close[top];
      MLP=MidL+zazor*Point;
      MLM=MidL-zazor*Point;

      MoveHLine("MidL",Time[0],MidL,Time[5],MidL,Gold,1,STYLE_DOT);
      MoveHLine("MLP",Time[0],MLP,Time[5],MLP,Lime,1,STYLE_DOT);
      MoveHLine("MLM",Time[0],MLM,Time[5],MLM,Magenta,1,STYLE_DOT);
      
      ft=false;
   }

   if(s + b == 0) {
      blok=0;
   } else {
      blok=1;
   }

   if(DayOfWeek()==2) dw="Monday";
   if(DayOfWeek()==3) dw="Tuesday";
   if(DayOfWeek()==4) dw="Wednesday";
   if(DayOfWeek()==5) dw="Thursday";
   if(DayOfWeek()==6) dw="Friday";
   
   if(Close[0]>MLP) del=MathRound((Close[0]-MLP)/Point);
   if(Close[0]<MLM) del=MathRound((MLM-Close[0])/Point);
   if(Close[0]<=MLP && Close[0]>=MLM) del=0;
                                         
   Comment("Data: ",Year(),".",Month(),".",Day(),"  Day=",dw,"  Time ",Hour(),":",Minute(),"  Tiks=",j,"\n","Blok=",blok,
           "  Delta=",del,"  Min=",MLM,"  Max=",MLP,"  Price=",Close[0]); 
           
   if(Hour()>0 && blok==0)
   {
      if(DayOfWeek()==6) return(0);
      if(del>5 && Close[0]>MLP)
      {
         s=s+1;
         Alert("Possible to place SellStop order at the price: ",MLP);
      }
      if(del>5 && Close[0]<MLM)
      {
         b=b+1;
         Alert("Possible to place BuyStop order at the price: ",MLM);
      }
   }      
           
   
//----
   return(0);
  }
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|                                                           |
//+------------------------------------------------------------------+
void MoveHLine(string name, datetime time, double price, datetime time1, double price1, 
                  int objcolor, int width, int style)
{
   if(ObjectFind(name)==-1)
   {
      ObjectCreate(name,OBJ_HLINE,0,time,price);
      ObjectSet(name, OBJPROP_COLOR, objcolor);
      ObjectSet(name, OBJPROP_WIDTH, width);
      ObjectSet(name, OBJPROP_STYLE, style);
   } else {
      ObjectMove(name, 1, time1, price1);
   }
}


//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }